package configurator;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.util.jar.*;
import java.util.zip.*;
/**
 * Publication configuration helper servlet.
 * Changes:<ul>
 * <li>Version 1.0.4: support for Cocoon with download from our site.</li></ul>
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0, 4
 * @see JSPservlet
 */
public class JSPservletConfig extends HttpServlet {
  /** Unique pagebox identifier. */
  String ID = null;
  /** keystore name. */
  String keystore = null;
  /** keystore password. */
  String keystorePassword = null;
  /** Certificate Authority URL. */
  String CAURL = null;
  /** Certificate Revocation List URL. */
  String CRLURL = null;
  /** User to use to connect to CA for certificate. */
  String CAuser = null;
  /** Password to use to connect to CA for certificate. */
  String CApassword = null;
  /** User to use to connect to CA for CRL. */
  String CRLuser = null;
  /** Password to use to connect to CA for CRL. */
  String CRLpassword = null;
  /** Static pages expiration time (sec). */
  int expiration = 0;
  /** Certificate Revocation List scan period. */
  int CRLperiod = 0;
  /** Cache directory path. */
  String CachePath = null;
  /** Log file cache. */
  String LogFile = null;
  /** Remote location property file path. */
  String RemoteLocations = null;
  /** Property file path of publisher location per archive. */
  String Publishers = null;
  /** all permission policy file path. */
  String AllPermissionPolicy = null;
  /** default property file path. */
  String DefaultPolicy = null;
  /** Version 1.0.4. Directory where to install ClassPath archives. */
  String ClassPathDir = null;
  /** Version 1.0.4. Mapping property file. */
  String PageboxMapping = null;
  /** name to use to invoke ServletLog. */
  String logName = null;
  /** name to use to invoke ServletStat. */
  String statName = null;
  /** trace mode. */
  boolean toTrace = true;
  /** stat mode. */
  boolean toStat = true;
  /** web.xml path. */
  String webXml = null;
  /** URL where to download JSPservlet. */
  String JSPservletURL = null;
  /** Application server current directory. */
  String curDir = null;
  /** msg buffer filled by check method. */
  String msg = "";
  HttpServletRequest request = null;
  HttpServletResponse response = null;
  InetAddress ia = null;
  /**
   * GET request handling.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    ia = InetAddress.getLocalHost();
    this.request = request;
    this.response = response;
    ID = request.getParameter("ID");
    keystore = request.getParameter("Keystore");
    keystorePassword = request.getParameter("Password");
    CAURL = request.getParameter("CAURL");
    CRLURL = request.getParameter("CRLURL");
    CAuser = request.getParameter("CAuser");
    CApassword = request.getParameter("CApassword");
    CRLuser = request.getParameter("CRLuser");
    CRLpassword = request.getParameter("CRLpassword");
    String szExpiration = request.getParameter("Expiration");
    if (szExpiration != null)
      expiration = Integer.parseInt(szExpiration);
    String szCRLperiod = request.getParameter("CRLperiod");
    if (szCRLperiod != null)
      CRLperiod = Integer.parseInt(szCRLperiod);
    CachePath = request.getParameter("CachePath");
    LogFile = request.getParameter("LogFile");
    RemoteLocations = request.getParameter("RemoteLocations");
    Publishers = request.getParameter("Publishers");
    AllPermissionPolicy = request.getParameter("AllPermissionPolicy");
    DefaultPolicy = request.getParameter("DefaultPolicy");
    logName = request.getParameter("LogName");
    statName = request.getParameter("StatName");
    ClassPathDir = request.getParameter("ClassPathDir");
    PageboxMapping = request.getParameter("PageboxMapping");
    webXml = request.getParameter("WebXml");
    JSPservletURL = request.getParameter("JSPservletURL");
    String szToGenerate = request.getParameter("Generate");
    String szToCheck = request.getParameter("Check");
    String szToSet = request.getParameter("Set");
    msg = null;
    PrintWriter out = response.getWriter();
    if (curDir == null) {
      File f = new File(".");
      curDir = f.getAbsolutePath();  // just an help - not a good value!
      if (curDir.endsWith(File.separator + "."))
        curDir = curDir.substring(0, curDir.length() -2);
    }
    if (szToGenerate != null) {
      if (generate(out, true))
        return;
    } else
    if (szToCheck != null)
      check();
    else
    if (szToSet != null)
      setenv();
    else
      initialize();
    out.println("<html>\n<head><title>JSPservletConfig</title></head>\n<body>");
    out.println("<h2><font color=#DB1260>JSPservlet configurator</font></h2><hr>");
    out.println("<form action=" + request.getRequestURI() + " method=\"GET\">");
    out.println("<table border=0 cellspacing=2 cellpadding=2 width=100%>");
    out.println(
"<font face=\"Arial\" size=2><tr><td width=35%><b>ID</b></td><td width=5% align=\"right\">" +
      "<font face=\"Arial\" color=#DB1260 size=2><b>*</b></font></td><td width=60%>" +
      "<input type=\"text\" name=\"ID\" size=60 value=\"" + ID + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Keystore</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"Keystore\" size=60 value=\"" + keystore +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Password</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"Password\" size=60 value=\"" +
      keystorePassword + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>CA certificate URL</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"CAURL\" size=60 value=\"" + CAURL +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>CRL certificate URL</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"CRLURL\" size=60 value=\"" + CRLURL +
      "\"></td></tr>");
    out.println(
      "<tr><td width=35%><b>CA user</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"CAuser\" size=60 value=\"" + CAuser +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>CA password</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"CApassword\" size=60 value=\"" + CApassword +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>CRL user</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"CRLuser\" size=60 value=\"" + CRLuser +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>CRL password</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"CRLpassword\" size=60 value=\"" + CRLpassword
      + "\"></td></tr>");
    out.println("<tr><td width=35%><b>Trace</b></td><td width=5%>&nbsp;</td>" +
      "<td width=5%><input type=\"checkbox\" " + (toTrace ? "checked" : "") +
      " name=\"trace\" value=on></td><td width=55%>&nbsp;</td></tr>");
    out.println("<tr><td width=35%><b>Statistics</b></td><td width=5%>&nbsp;</td>" +
      "<td width=5%><input type=\"checkbox\" " + (toStat ? "checked" : "") +
      " name=\"stat\" value=on></td><td width=55%>&nbsp;</td></tr>");
    out.println(
"<tr><td width=35%><b>Resource expiration time</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"Expiration\" size=60 value=\"" + expiration +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>CRL scan period</b></td><td width=5%>&nbsp;</td><td width=60%>"
      + "<input type=\"text\" name=\"CRLperiod\" size=60 value=\"" + CRLperiod +
      "\"></td></tr>");
    out.println(
      "<tr><td width=35%><b>Cache path</b></td><td width=5% align=\"right\">" +
      "<font face=\"Arial\" color=#DB1260 size=2><b>*</b></font></td><td width=60%>"
      + "<input type=\"text\" name=\"CachePath\" size=60 value=\"" + CachePath +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Log file</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"LogFile\" size=60 value=\"" + LogFile +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Remote location property file</b></td><td width=5%>&nbsp;</td><td width=60%>"
      + "<input type=\"text\" name=\"RemoteLocations\" size=60 value=\"" +
      RemoteLocations + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Publishers property file</b></td><td width=5%>&nbsp;</td><td width=60%>"
      + "<input type=\"text\" name=\"Publishers\" size=60 value=\"" +
      Publishers + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>AllPermission policy file</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"AllPermissionPolicy\" size=60 value=\"" +
      AllPermissionPolicy + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Default policy file</b></td><td width=5%>&nbsp;</td>" +
      "<td width=60%><input type=\"text\" name=\"DefaultPolicy\" size=60 value=\"" +
      DefaultPolicy + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Support lib directory</b></td><td width=5%>&nbsp;</td><td width=60%>"
      + "<input type=\"text\" name=\"ClassPathDir\" size=60 value=\"" +
      ClassPathDir + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>Mapping property file</b></td><td width=5%>&nbsp;</td><td width=60%>"
      + "<input type=\"text\" name=\"PageboxMapping\" size=60 value=\"" +
      PageboxMapping + "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>ServletLog name</b></td><td width=5%>&nbsp;</td><td width=60%>"
      + "<input type=\"text\" name=\"LogName\" size=60 value=\"" + logName +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>ServletStat name</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"StatName\" size=60 value=\"" + statName +
      "\"></td></tr></font></table><font face=\"Arial\" size=2>");
    out.println("<p>The following two parameters are used only "
      + "if you click set and want to upload JSPservlet.</p></font>");
    out.println("<table border=0 cellspacing=2 cellpadding=2 width=100%>");
    out.println("<font face=\"Arial\" size=2>" +
"<tr><td width=35%><b>web.xml directory</b></td><td width=5% align=\"right\">" +
"<font face=\"Arial\" color=green size=2><b>*</b></font></td><td width=60%>" +
      "<input type=\"text\" name=\"WebXml\" size=60 value=\"" + webXml +
      "\"></td></tr>");
    out.println(
"<tr><td width=35%><b>JSPservlet URL</b></td><td width=5% align=\"right\">" +
"<font face=\"Arial\" color=green size=2><b>*</b></font></td><td width=60%>" +
      "<input type=\"text\" name=\"JSPservletURL\" size=60 value=\"" +
      JSPservletURL + "\"></td></tr></font></table>");
    out.println("<table border=0 cellspacing=2 cellpadding=2 width=100%>");
    out.println("<font face=\"Arial\" size=2>" +
      "<tr><td width=20%><input type=\"Submit\" value=\"Check\" name=\"Check\"></td>" +
      "<td width=20%><input type=\"Submit\" value=\"Generate\" name=\"Generate\">" +
      "</td><td width=20%><input type=\"Submit\"value=\"Set\" name=\"Set\"></td>");
    out.println(
"<td width=40%>&nbsp;</td></tr></font></table><hr><font face=\"Arial\" size=2>");
    if (msg.length() > 0)
      out.println(msg);
    else
      out.println("No message");
    out.println(
      "<hr>Alexis Grandemange (c) 2000-2001 GNU GPL 2\n</font></body></html>");
    out.flush();
  }
  /** Initialize parameters. */
  private final void initialize() {
    ID = "";
    keystore = "keystore";
    keystorePassword = "keystorePassword";
    CAURL = "";
    CRLURL = "";
    CAuser = "";
    CApassword = "";
    CRLuser = "";
    CRLpassword = "";
    toTrace = toStat = true;
    CachePath = curDir;
    expiration = 30;
    CRLperiod = 30;
    LogFile = CachePath + File.separator + "JSPservlet.log";
    RemoteLocations = CachePath + File.separator + "remoteLocation.properties";
    Publishers = CachePath + File.separator + "publisher.properties";
    AllPermissionPolicy = CachePath + File.separator + "allPermission.policy";
    DefaultPolicy = CachePath + File.separator + "default.policy";
    ClassPathDir = CachePath + File.separator + "lib";
    PageboxMapping = CachePath + File.separator + "mapping-cocoon.properties";
    logName = "ServletLog";
    statName = "ServletStat";
    webXml = CachePath + File.separator + "WEB-INF";
    msg = "";
    /*
     * We use com.caucho.jsp.QJspFactory as in JSPservlet to minimize
     * dependencies. Here we select the archive to download depending on
     * the configurator application server.
     */
    try {
      Class c = Class.forName("com.caucho.jsp.QJspFactory");
      if (c == null)
        return;
      JSPservletURL = "http://pagebox.net/resin.jar";
    }
    catch(Exception e) {}
    if (JSPservletURL == null)
      JSPservletURL = "http://pagebox.net/tomcat.jar";
  }
  /** Checks parameter validity */
  private final void check() {
    msg = "";
    if ((ID == null) || (ID.length() == 0))
      msg +=
"<font color=green face=\"Arial\" size=2><b>Mandatory: ID must be set.</b></font><BR>\n";
    if ((CachePath != null) && (CachePath.length() > 0)) {
      File f = new File(CachePath);
      if (!f.exists())
        msg += "Warning: " + CachePath + " doesn't exist.<BR>\n";
      else
      if (!f.isDirectory())
        msg += "<font color=red face=\"Arial\" size=2><b>Error: " + CachePath +
          " is not a directory.</b></font><BR>\n";
      if (CachePath.equals(curDir))
        msg += "Warning: Do you really want to use " + CachePath +
          " as cache path?<BR>\n";
      else {
        if (LogFile == null || LogFile.length() == 0 || LogFile.startsWith(curDir))
          LogFile = CachePath + File.separator + "JSPservlet.log";
        if (RemoteLocations == null || RemoteLocations.length() == 0 ||
          RemoteLocations.startsWith(curDir))
          RemoteLocations = CachePath + File.separator +
            "remoteLocation.properties";
        if (Publishers == null || Publishers.length() == 0 ||
          Publishers.startsWith(curDir))
          Publishers = CachePath + File.separator + "publisher.properties";
        if (AllPermissionPolicy == null || AllPermissionPolicy.length() == 0)
          AllPermissionPolicy = CachePath + File.separator +
            "allPermission.policy";
        else {
          f = new File(AllPermissionPolicy);
          if (!f.exists() && AllPermissionPolicy.startsWith(curDir))
            AllPermissionPolicy = CachePath + File.separator +
              "allPermission.policy";
        }
        if (DefaultPolicy == null || DefaultPolicy.length() == 0)
          DefaultPolicy = CachePath + File.separator + "default.policy";
        else {
          f = new File(DefaultPolicy);
          if (!f.exists() && DefaultPolicy.startsWith(curDir))
            DefaultPolicy = CachePath + File.separator + "default.policy";
        }
        if (ClassPathDir == null || ClassPathDir.length() == 0)
          ClassPathDir = CachePath + File.separator + "lib";
        else {
          if (ClassPathDir.startsWith(curDir))
            ClassPathDir = CachePath + File.separator + "lib";
        }
        if (PageboxMapping == null || PageboxMapping.length() == 0)
          PageboxMapping = CachePath + File.separator +
            "mapping-cocoon.properties";
        else {
          f = new File(PageboxMapping);
          if (!f.exists() && PageboxMapping.startsWith(curDir))
            PageboxMapping = CachePath + File.separator +
              "mapping-cocoon.properties";
        }
        if (webXml == null || webXml.length() == 0)
          webXml = CachePath + File.separator + "WEB-INF";
        else {
          f = new File(webXml);
          if (!f.exists() && webXml.startsWith(curDir))
            webXml = CachePath + File.separator + "WEB-INF";
        }
      }
    } else
      msg += "Warning: cache path is not set<BR>\n";
    if ((LogFile != null) && (LogFile.length() > 0)) {
      File f = new File(LogFile);
      f = f.getParentFile();
      if (!f.exists())
        msg += "Warning: directory where to create logs (" + f.getName() +
          ") doesn't exist<BR>\n";
      else
      if (!f.canWrite())
        msg +=
"<font color=red face=\"Arial\" size=2><b>Error: unable to create log file in " +
          f.getAbsolutePath() + "</b></font><BR>\n";
    } else
      msg += "Warning: log file is not set<BR>\n";
    if ((RemoteLocations != null) && (RemoteLocations.length() > 0)) {
      File f = new File(RemoteLocations);
      f = f.getParentFile();
      if (!f.exists())
        msg += "Warning: directory where to create remote locations property file ("
          + f.getName() + ") doesn't exist<BR>\n";
      else
      if (!f.canWrite())
        msg += "<font color=red face=\"Arial\" size=2><b>Error: " +
          "unable to create remote locations property file in " +
          f.getAbsolutePath() + "</b></font><BR>\n";
    } else
      msg += "Warning: remote locations property file is not set<BR>\n";
    if ((Publishers != null) && (Publishers.length() > 0)) {
      File f = new File(Publishers);
      f = f.getParentFile();
      if (!f.exists())
        msg +=
    "Warning: directory where to create publishers per archive property file ("
          + f.getName() + ") doesn't exist<BR>\n";
      else
      if (!f.canWrite())
        msg += "<font color=red face=\"Arial\" size=2><b>Error: " +
          "unable to create publishers per archive property file in " +
          f.getAbsolutePath() + "</b></font><BR>\n";
    } else
      msg += "Warning: publishers per archive property file is not set<BR>\n";
    if ((AllPermissionPolicy != null) && (AllPermissionPolicy.length() > 0)) {
      File f = new File(AllPermissionPolicy);
      if (!f.exists())
        msg += "Warning: allPermission policy " + AllPermissionPolicy +
          " doesn't exist<BR>\n";
    } else
      msg += "Warning: allPermission policy file is not set<BR>\n";
    if ((DefaultPolicy != null) && (DefaultPolicy.length() > 0)) {
      File f = new File(DefaultPolicy);
      if (!f.exists())
        msg += "Warning: default policy " + DefaultPolicy + " doesn't exist<BR>\n";
    } else
      msg += "Warning: default policy file is not set<BR>\n";
    if ((ClassPathDir != null) && (ClassPathDir.length() > 0)) {
      File f = new File(ClassPathDir);
      if (!f.exists())
        msg += "Warning: support archive directory " + ClassPathDir +
          " doesn't exist<BR>\n";
    } else
      msg += "Warning: support archive directory is not set<BR>\n";
    if ((PageboxMapping != null) && (PageboxMapping.length() > 0)) {
      File f = new File(PageboxMapping);
      if (!f.exists())
        msg += "Warning: Mapping property file " + PageboxMapping +
          " doesn't exist<BR>\n";
    } else
      msg += "Warning: Mapping property file is not set<BR>\n";
    if (request.getParameter("trace") != null)
      toTrace = true;
    else
      toTrace = false;
    if (request.getParameter("stat") != null)
      toStat = true;
    else
      toStat = false;
  }
  /**
   * Generates and returns a web.xml file.
   * @param     out PrintWriter.
   * @param     bHTTP true - set response time (HTTP flow).
   */
  private final boolean generate(PrintWriter out, boolean bHTTP) {
    if (bHTTP)
      msg = "";
    if ((ID == null) || (ID.length() == 0)) {
      msg = "ID must be set to generate\n";
      return false;
    }
    if ((CachePath == null) || (CachePath.length() == 0)) {
      File f = new File(ID);
      CachePath = f.getAbsolutePath();
    }
    if ((LogFile == null) || (LogFile.length() == 0))
      LogFile = CachePath + File.separator + "JSPservlet.log";
    if ((RemoteLocations == null) || (RemoteLocations.length() == 0))
      RemoteLocations = CachePath + File.separator + "remoteLocation.properties";
    if ((Publishers == null) || (Publishers.length() == 0))
      Publishers = CachePath + File.separator + "publisher.properties";
    if ((AllPermissionPolicy == null) || (AllPermissionPolicy.length() == 0))
      AllPermissionPolicy = CachePath + File.separator + "allPermission.policy";
    if ((DefaultPolicy == null) || (DefaultPolicy.length() == 0))
      DefaultPolicy = CachePath + File.separator + "default.policy";
    if (bHTTP)
      response.setContentType("text/xml");
    out.println(
"<!DOCTYPE web-app\nPUBLIC \"-//Sun Microsystems, Inc.//DTD Web Application 2.2//EN\"\n" +
      "\"http://java.sun.com/j2ee/dtds/web-app_2_2.dtd\">");
    out.println("<!-- Review on " + ia.getHostName() + "\n");
    File f = new File(CachePath);
    if (!f.exists())
      out.println(
        "\tACTION: Create CachePath:"+ CachePath + " Reason: doesn't exist\n");
    else
    if (!f.isDirectory())
      out.println("\tERROR: CachePath:" + CachePath + " is not a directory\n");
    else
    if (!f.canWrite())
      out.println(
"\tERROR: Appplication Server account doesn't have write access on CachePath:" +
        CachePath + "\n");
    f = new File(LogFile);
    f = f.getParentFile();
    if (!f.exists())
      out.println("\tACTION: Create parent dir of LogFile:" + LogFile +
        " Reason: doesn't exist\n");
    f = new File(RemoteLocations);
    f = f.getParentFile();
    if (!f.exists())
      out.println("\tACTION: Create parent dir of RemoteLocations:" +
        RemoteLocations + " Reason: doesn't exist\n");
    f = new File(Publishers);
    f = f.getParentFile();
    if (!f.exists())
      out.println("\tACTION: Create parent dir of Publishers:" + Publishers +
        " Reason: doesn't exist\n");
    f = new File(AllPermissionPolicy);
    if (!f.exists())
      out.println("\tACTION: Create AllPermission policy file:" +
        AllPermissionPolicy + " or comment it. Reason: doesn't exist\n" +
        "\tNOTE: if you comment it the archives will run without sandbox\n");
    f = new File(DefaultPolicy);
    if (!f.exists())
      out.println("\tACTION: Create default policy file:" + DefaultPolicy +
        " or comment it. Reason: doesn't exist\n" +
        "\tNOTE: if you comment it the archives will run without sandbox\n");
    f = new File(ClassPathDir);
    if (!f.exists())
      out.println("\tACTION: Create and populate support archive directory:" +
        ClassPathDir + " or comment it. Reason: doesn't exist\n" +
        "\tNOTE: if you comment it you will run without support archives\n");
    f = new File(PageboxMapping);
    if (!f.exists())
      out.println("\tACTION: Create Mapping property file:" + PageboxMapping +
        " or comment it. Reason: doesn't exist\n" +
        "\tNOTE: if you comment it you will run without mapping\n");
    out.println("-->\n");
    if (expiration == 0)
      expiration = 30;
    if (CRLperiod == 0)
      CRLperiod = 30;
    out.println("\n\n<web-app>\n\t<servlet>\n\t\t<servlet-name>JSPservlet" +
"</servlet-name>\n\t\t<servlet-class>JSPservletPkg.JSPservlet</servlet-class>\n");
    out.println(genParm("cachePath", CachePath.replace('\\', '/'), "local cache"));
    if (request.getParameter("trace") != null) {
      toTrace = true;
      out.println(genParm("toTrace", "TRUE", "trace activation"));
    } else {
      toTrace = true;
      out.println(genParm("toTrace", "FALSE", "trace activation"));
    }
    if (request.getParameter("stat") != null) {
      toStat = true;
      out.println(genParm("toStat", "TRUE", "stat activation"));
    } else {
      toStat = false;
      out.println(genParm("toStat", "FALSE", "stat activation"));
    }
    out.println(genParm("ID", ID, "unique identifier"));
    out.println(genParm("logfile", LogFile.replace('\\', '/'), "trace location"));
    out.println(genParm("remoteLocations", RemoteLocations.replace('\\', '/'),
      "jar remote location"));
    out.println(genParm("Publishers", Publishers.replace('\\', '/'),
      "Publishers per archive"));
    out.println(genParm("allPermissionPolicy",
      AllPermissionPolicy.replace('\\', '/'), "policy file granting all rights"));
    out.println(genParm("defaultPolicy", DefaultPolicy.replace('\\', '/'),
      "policy file for archives without explicit policy"));
    out.println(genParm("keystore", keystore,
      "keystore location + download policy"));
    out.println(genParm("keystorePassword", keystorePassword,
      "keystore password"));
    if ((CRLURL == null) || (CRLURL.length() == 0)) {
      out.println("\t\t<!-- Uncomment the line if you fill the URL\n");
      out.println(genParm("CRLURL", "LDAP://directory.verisign.com",
        "Certificate Revocation List LDAP URL"));
      out.println("\t\t-->\n");
    } else
      out.println(genParm("CRLURL", CRLURL,
        "Certificate Revocation List LDAP URL"));
    if ((CAURL == null) || (CAURL.length() == 0)) {
      out.println("\t\t<!-- Uncomment the line if you fill the URL\n");
      out.println(genParm("CAURL", "LDAP://directory.verisign.com",
        "CA Certificate LDAP URL"));
      out.println("\t\t-->\n");
    } else
      out.println(genParm("CAURL", CAURL, "CA Certificate LDAP URL"));
    if ((CRLuser == null) || (CRLuser.length() == 0)) {
      out.println("\t\t<!-- Uncomment the line if you fill the identifier\n");
      out.println(genParm("CRLLDAPuser", CRLuser, "CRL LDAP user"));
      out.println("\t\t-->\n");
    } else
      out.println(genParm("CRLLDAPuser", CRLuser, "CRL LDAP user"));
    if ((CRLpassword == null) || (CRLpassword.length() == 0)) {
      out.println("\t\t<!-- Uncomment the line if you fill the password\n");
      out.println(genParm("CRLLDAPpasswd", CRLpassword, "CRL LDAP password"));
      out.println("\t\t-->\n");
    } else
      out.println(genParm("CRLLDAPpasswd", CRLpassword, "CRL LDAP password"));
    if ((CAuser == null) || (CAuser.length() == 0)) {
      out.println("\t\t<!-- Uncomment the line if you fill the identifier\n");
      out.println(genParm("CALDAPuser", CAuser, "CA certificate LDAP user"));
      out.println("\t\t-->\n");
    } else
      out.println(genParm("CALDAPuser", CAuser, "CA certificate LDAP user"));
    if ((CApassword == null) || (CApassword.length() == 0)) {
      out.println("\t\t<!-- Uncomment the line if you fill the password\n");
      out.println(genParm("CALDAPpasswd", CApassword,
        "CA certificate LDAP password"));
      out.println("\t\t-->\n");
    } else
      out.println(genParm("CALDAPpasswd", CApassword,
        "CA certificate LDAP password"));
    out.println(genParm("expiration", "" + expiration, "resource expiration time"));
    out.println(genParm("CRLperiod", "" + CRLperiod,
      "Certificate Revocation List scan period"));
    out.println(genParm("ErrorPage", "/JSPerror.html",
      "Page to display in case of unidentified error"));
    out.println(genParm("NotFoundPage", "/JSPnotFound.html",
      "Page to display when target servlet not found"));
    out.println(genParm("UnauthorizedPage", "/JSPunauthorized.html",
      "Target page tried an unauthorized access"));
    out.println(genParm("RevokedPage", "/JSPrevoked.html",
      "Revoked archive certificate"));
    String classPathDir = ClassPathDir.replace('\\', '/');
    String classPath = classPathDir + "/InputSource.jar" + File.pathSeparator;
    classPath += (classPathDir + "/xerces_1_2.jar" + File.pathSeparator);
    classPath += (classPathDir + "/turbine-pool.jar" + File.pathSeparator);
    classPath += (classPathDir + "/w3c.jar" + File.pathSeparator);
    classPath += (classPathDir + "/bsf.jar" + File.pathSeparator);
    classPath += (classPathDir + "/xalan_1_2_D02.jar" + File.pathSeparator);
    classPath += (classPathDir + "/fop_0_15_0.jar" + File.pathSeparator);
    classPath += (classPathDir + "/cocoonPatch.jar" + File.pathSeparator);
    classPath += (classPathDir + "/cocoon.jar" + File.pathSeparator);
    classPath += (classPathDir + "/xml.jar" + File.pathSeparator);
    classPath += (classPathDir + "/activation.jar" + File.pathSeparator);
    classPath += (classPathDir + "/mail.jar" + File.pathSeparator);
    classPath += (classPathDir + "/soap.jar" + File.pathSeparator);
    classPath += (classPathDir + "/loopback.jar" + File.pathSeparator);
    classPath += (classPathDir + "/cocoonSupport.jar");
    out.println(genParm("ClassPath", classPath,
      "policy file for archives without explicit policy"));
    out.println(genParm("PageboxMapping", PageboxMapping.replace('\\', '/'),
      "Mapping property file"));
    /** Cocoon parameters. */
    out.println(genParm("properties", "WEB-INF/cocoon.properties",
      "Cocoon properties"));
    /** SOAP parameters. */
    out.println(genParm("faultListener", "org.apache.soap.server.DOMFaultListener",
      "SOAP parameter"));
    out.println(
"\t</servlet>\n\n\t<servlet>\n\t\t<servlet-name>ServletUpdate</servlet-name>\n\t\t" +
"<servlet-class>JSPservletPkg.ServletUpdate</servlet-class>\n\t</servlet>\n\n");
    out.println("\t<servlet>\n\t\t<servlet-name>ServletLog</servlet-name>\n\t\t" +
"<servlet-class>JSPservletPkg.ServletLog</servlet-class>\n\t</servlet>\n\n");
    out.println("\t<servlet>\n\t\t<servlet-name>ServletStat</servlet-name>\n\t\t" +
"<servlet-class>JSPservletPkg.ServletStat</servlet-class>\n\t</servlet>\n\n");
    out.println(genMapping("ServletUpdate", "ServletUpdate"));
    out.println(genMapping("ServletLog", logName));
    out.println(genMapping("ServletStat", statName));
    out.println(genMapping("JSPservlet", "/"));
    out.println("</web-app>");
    return true;
  }
  /**
   * Service method invoked by generate. Builds a parameter entry (web.xml).
   * @param     name parameter name.
   * @param     value parameter value.
   * @param     descr parameter description.
   */
  static final String genParm(String name, String value, String descr) {
    return "\t\t<init-param>\n\t\t<param-name>" + name +
      "</param-name>\n\t\t<param-value>" + value +
      "</param-value>\n\t\t<description>" + descr +
      "</description>\n\t\t</init-param>\n";
  }
  /**
   * Service method invoked by generate. Builds a servlet mapping (web.xml).
   * @param     name servlet name.
   * @param     value servlet invocation name.
   */
  static final String genMapping(String name, String value) {
    return "\t<servlet-mapping>\n\t\t<servlet-name>" + name + "</servlet-name>" +
      "\n\t\t<url-pattern>" + (value.startsWith("/") ? value : "/" + value) +
      "</url-pattern>\n\t</servlet-mapping>\n\n";
  }
  /**
   * method setting remote environment in order to host JSPservlet.
   * should be invoked only if JSPservletConfig is installed on the target machine.
   */
  void setenv() {
    msg = "";
    if (request.getParameter("trace") != null)
      toTrace = true;
    else
      toTrace = false;
    if (request.getParameter("stat") != null)
      toStat = true;
    else
      toStat = false;
    if ((CachePath != null) && (CachePath.length() > 0) &&
      !CachePath.equals(curDir)) {
      File f = new File(CachePath);
      if (!f.exists())
        f.mkdirs();
    }
    if ((LogFile != null) && (LogFile.length() > 0)) {
      File f = new File(LogFile);
      f = f.getParentFile();
      if (!f.exists())
        f.mkdirs();
    }
    if ((RemoteLocations != null) && (RemoteLocations.length() > 0)) {
      File f = new File(RemoteLocations);
      f = f.getParentFile();
      if (!f.exists())
        f.mkdirs();
    }
    if ((Publishers != null) && (Publishers.length() > 0)) {
      File f = new File(Publishers);
      f = f.getParentFile();
      if (!f.exists())
        f.mkdirs();
    }
    if ((AllPermissionPolicy != null) && (AllPermissionPolicy.length() > 0)) {
      File f = new File(AllPermissionPolicy);
      if (!f.exists()) {
        File p = f.getParentFile();
        if (!p.exists())
          p.mkdirs();
      }
      PrintWriter pw = null;
      try {
        pw = new PrintWriter(new BufferedWriter(
          new FileWriter(AllPermissionPolicy, false)));
      }
      catch(IOException ioe) {
        msg +=
          "<font color=red face=\"Arial\" size=2><b>Error: unable to create " +
          AllPermissionPolicy + "<BR>\n" + ioe + "</b></font><BR>\n";
        return;
      }
      pw.println("grant {");
      pw.println("\tpermission java.security.AllPermission;");
      pw.println("};");
      pw.close();
    }
    if ((DefaultPolicy != null) && (DefaultPolicy.length() > 0)) {
      File f = new File(DefaultPolicy);
      if (!f.exists()) {
        File p = f.getParentFile();
        if (!p.exists())
          p.mkdirs();
      }
      PrintWriter pw = null;
      try {
        pw = new PrintWriter(new BufferedWriter(
          new FileWriter(DefaultPolicy, false)));
      }
      catch(IOException ioe) {
        msg +=
          "<font color=red face=\"Arial\" size=2><b>Error: unable to create " +
          DefaultPolicy + "<BR>\n" + ioe + "</b></font><BR>\n";
        return;
      }
      pw.println("grant {");
      pw.println("\tpermission java.util.PropertyPermission \"*\", \"read\";");
      pw.println("};");
      pw.close();
    }
    if ((ClassPathDir != null) && (ClassPathDir.length() > 0)) {
      File f = new File(ClassPathDir);
      if (!f.exists())
        f.mkdirs();
      else
      if (!f.isDirectory()) {
        msg += "<font color=red face=\"Arial\" size=2><b>Error: " + ClassPathDir
          + " is not a directory<BR>\n";
        return;
      }
      copy("InputSource.jar", "http://pagebox.net/");
      copy("xerces_1_2.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("turbine-pool.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("w3c.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("bsf.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("xalan_1_2_D02.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("fop_0_15_0.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("cocoonPatch.jar", "http://pagebox.net/");
      copy("cocoon.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("xml.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("activation.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("mail.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("soap.jar", "http://pagebox.sourceforge.net/cocoon1.8.2-lib/");
      copy("loopback.jar", "http://pagebox.net/");
      copy("cocoonSupport.jar", "http://pagebox.net/");
    }
    if ((PageboxMapping != null) && (PageboxMapping.length() > 0)) {
      File f = new File(PageboxMapping);
      if (!f.exists()) {
        File p = f.getParentFile();
        if (!p.exists())
          p.mkdirs();
      }
      try {
        URL url = new URL(
    "http://pagebox.sourceforge.net/cocoon1.8.2-lib/mapping-cocoon.properties");
        InputStream is = url.openStream();
        BufferedOutputStream bos = new BufferedOutputStream(
          new FileOutputStream(PageboxMapping));
        BufferedInputStream bis = new BufferedInputStream(is);
        int i;
        while((i = bis.read()) != -1)
          bos.write(i);
        bos.close();
        bis.close();
      }
      catch(Exception e) {
        msg +=
          "<font color=red face=\"Arial\" size=2><b>Error: unable to access " +
      "http://pagebox.sourceforge.net/cocoon1.8.2-lib/mapping-cocoon.properties"
          + "<BR>\n" + e + "</b></font><BR>\n";
      }
    }
    File parent = null; // created in webXml step and used in JSPservletURL step
    if ((webXml != null) && (webXml.length() > 0)) {
      if (!webXml.endsWith("WEB-INF")) {
        msg +=
"<font color=red face=\"Arial\" size=2><b>Error: invalid web.xml directory:" +
          webXml + ". Should end with WEB-INF</b></font><BR>\n";
        return;
      }
      File f = new File(webXml);
      if (!f.exists())
        f.mkdirs();
      PrintWriter pw = null;
      try {
        pw = new PrintWriter(new BufferedWriter(
          new FileWriter(webXml + File.separator + "web.xml", false)));
      }
      catch(IOException ioe) {
        msg +=
          "<font color=red face=\"Arial\" size=2><b>Error: unable to create " +
          File.separator + "web.xml" + webXml + "<BR>\n" + ioe +
          "</b></font><BR>\n";
        return;
      }
      generate(pw, false);
      pw.close();
      parent = f.getParentFile();
      try {
        URL url = new URL(
          "http://pagebox.sourceforge.net/cocoon1.8.2-lib/cocoon.properties");
        InputStream is = url.openStream();
        pw = new PrintWriter(new BufferedWriter(
          new FileWriter(webXml + File.separator + "cocoon.properties", false)));
        BufferedReader br = new BufferedReader(new InputStreamReader(is));
        String line = null;
        while((line = br.readLine()) != null) {
          int idx = line.indexOf(
            "/usr/local/etc/httpd/sites/pagebox.net/JSPservletDemo");
          if (idx == -1) {
            pw.println(line);
            continue;
          }
          String toPrint = line.substring(0, idx);
          toPrint += CachePath.replace('\\', '/');
          toPrint += line.substring(idx +
            "/usr/local/etc/httpd/sites/pagebox.net/JSPservletDemo".length());
          pw.println(toPrint);
        }
        pw.close();
        br.close();
      }
      catch(Exception e) {
        msg +=
          "<font color=red face=\"Arial\" size=2><b>Error: unable to access " +
      "http://pagebox.sourceforge.net/cocoon1.8.2-lib/cocoon.properties"
          + "<BR>\n" + e + "</b></font><BR>\n";
      }
    }
    if ((JSPservletURL != null) && (JSPservletURL.length() > 0)) {
      try {
        URL url = new URL(JSPservletURL);
        InputStream is = url.openStream();
        JarInputStream jis = new JarInputStream(is);
        JarEntry je = null;
        while((je = jis.getNextJarEntry()) != null) {
          String entryName = je.getName();
          if ((entryName.startsWith(webInfClasses) &&
            entryName.endsWith(".class")) || entryName.endsWith(".html")) {
            BufferedInputStream bis = new BufferedInputStream(jis);
            File f = new File(parent, entryName);
            File p = f.getParentFile();
            if (!p.exists())
              p.mkdirs();
            BufferedOutputStream bos = new BufferedOutputStream(
              new FileOutputStream(f));
            int i;
            while((i = bis.read()) != -1)
              bos.write(i);
            bos.close();
            // bis.close();
          }
        }
        is.close();
      }
      catch(Exception e) {
        msg += "<font color=red face=\"Arial\" size=2><b>Error: unable to access "
          + JSPservletURL + "<BR>\n" + e + "</b></font><BR>\n";
        return;
      }
    }
  }
  /** Version 1.0.4.
   * Service method to download support archives from a repository.
   * @param archive archive name.
   * @param Url archive download url.
   */
  void copy(String archive, String Url) {
    try {
      File f = new File(ClassPathDir + File.separator + archive);
      // If the archive exists don't download it again.
      // Rationale: most of the time either all the archive is transfered or
      // nothing
      if (f.exists())
        return;
      URL url = new URL(Url + archive);
      InputStream is = url.openStream();
      BufferedOutputStream bos = new BufferedOutputStream(
        new FileOutputStream(f));
      BufferedInputStream bis = new BufferedInputStream(is);
      int i;
      while((i = bis.read()) != -1)
        bos.write(i);
      bos.close();
      bis.close();
    }
    catch(Exception e) {
      msg += "<font color=red face=\"Arial\" size=2><b>Error: unable to access "
        + Url + archive + "<BR>\n" + e + "</b></font><BR>\n";
      return;
    }
  }
  /** copy classes found there and html without path */
  private static final String webInfClasses = "WEB-INF/classes/";
}


