package configurator;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.util.jar.*;
import java.util.zip.*;
/**
 * Publication configuration helper servlet.
 * Changes:
 * <p>Copyright (c) 2000-2001 Alexis Grandemange</p>
 * <pre>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * </pre>
 * <p>I included a copy of the GNU Lesser General Public License lesser.txt
 * in this directory.</p>
 * <p>alexis.grandemange@pagebox.net</p>
 * @author  Alexis Grandemange
 * @version 1, 0, 4
 * @see JSPservlet
 */
public class PublishConfig extends HttpServlet {
  /** Directory where to upload archives.
   * Repository and repositoryURL point the same dir.
   * So a file copied in Repository should be downloaded from repositoryURL */
  String Repository = null;
  /** URL where to download archives. */
  String repositoryURL = null;
  /** Archive maximum size. */
  int MaxLength = 0;
  /** Log file path. */
  String Logfile = null;
  /** Serialized file describing target PageBoxes. */
  String PageBoxURLs = null;
  /** web.xml path. */
  String webXml = null;
  /** URL where to download PublishServer. */
  String publisherURL = null;
  /** msg buffer filled by check method. */
  String msg = "";
  /** trace mode. */
  boolean toTrace = true;
  String curDir = null;
  HttpServletRequest request = null;
  HttpServletResponse response = null;
  InetAddress ia = null;
  /**
   * GET request handling.
   * @param     request HttpServletRequest.
   * @param     response HttpServletResponse.
   */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    ia = InetAddress.getLocalHost();
    this.request = request;
    this.response = response;
    Repository = request.getParameter("Repository");
    repositoryURL = request.getParameter("repositoryURL");
    PageBoxURLs = request.getParameter("PageBoxURLs");
    String szMaxLength = request.getParameter("MaxLength");
    if (szMaxLength != null)
      MaxLength = Integer.parseInt(szMaxLength);
    Logfile = request.getParameter("Logfile");
    webXml = request.getParameter("WebXml");
    publisherURL = request.getParameter("publisherURL");
    String szToGenerate = request.getParameter("Generate");
    String szToSet = request.getParameter("Set");
    String szToCheck = request.getParameter("Check");
    PrintWriter out = response.getWriter();
    if (curDir == null) {
      File f = new File(".");
      curDir = f.getAbsolutePath();  // just an help - not a good value!
      if (curDir.endsWith(File.separator + "."))
        curDir = curDir.substring(0, curDir.length() -2);
    }
    if (szToGenerate != null) {
      if (generate(out, true))
        return;
    } else
    if (szToCheck != null)
      check();
    else
    if (szToSet != null)
      setenv();
    else
      initialize();
    out.println("<html>\n<head><title>PublishConfig</title></head>\n<body>");
    out.println("<h2><font color=#DB1260>Publisher configurator</font></h2><hr>");
    out.println("<form action=" + request.getRequestURI() + " method=\"GET\">");
    out.println(
"<table border=0 cellspacing=2 cellpadding=2 width=100%><font face=\"Arial\" size=2>");
    out.println(
"<tr><td width=35%><b>Repository directory</b></td><td width=5% align=\"right\">" +
      "<font face=\"Arial\" color=#DB1260 size=2><b>*</b></font>" +
      "</td><td width=60%><input type=\"text\" name=\"Repository\" value=\"" +
      Repository + "\" size=\"60\"></td></tr>");
out.println("<tr><td width=35%><b>Repository URL</b></td><td width=5% align=\"right\">" +
      "<font face=\"Arial\" color=#DB1260 size=2><b>*</b></font></td>" +
      "<td width=60%><input type=\"text\" name=\"repositoryURL\" value=\"" +
      repositoryURL + "\" size=\"60\"></td></tr>");
    out.println(
      "<tr><td width=35%><b>PageBoxURLs serialized file</b></td><td width=5%>" +
      "&nbsp;</td><td width=60%><input type=\"text\" name=\"PageBoxURLs\" value=\""
      + PageBoxURLs + "\" size=\"60\"></td></tr>");
    out.println(
      "<tr><td width=35%><b>Max archive size</b></td><td width=5%>&nbsp;</td>" +
      "<td width=60%><input type=\"text\" name=\"MaxLength\" value=\"" +
      MaxLength + "\" size=\"60\"></td></tr>");
    out.println(
      "<tr><td width=35%><b>Log file</b></td><td width=5%>&nbsp;</td><td width=60%>" +
      "<input type=\"text\" name=\"Logfile\" value=\"" + Logfile +
      "\" size=\"60\"></td></tr>");
    out.println("<tr><td width=35%><b>Trace</b></td><td width=5%>&nbsp;</td>" +
      "<td width=5%><input type=\"checkbox\" " + (toTrace ? "checked" : "") +
      " name=\"trace\" value=on></td><td width=55%>&nbsp;</td></tr>");
    out.println(
      "<tr><td width=35%><b>web.xml directory</b></td><td width=5% align=\"right\">" +
      "<font face=\"Arial\" color=green size=2><b>*</b></font></td>" +
      "<td width=60%><input type=\"text\" name=\"WebXml\" value=\"" + webXml +
      "\" size=\"60\"></td></tr>");
    out.println(
"<tr><td width=35%><b>PublisherServer URL</b></td><td width=5% align=\"right\">" +
"<font face=\"Arial\" color=green size=2><b>*</b></font></td></td><td width=60%>" +
      "<input type=\"text\" name=\"publisherURL\" value=\"" + publisherURL +
      "\" size=\"60\"></td></tr></table><table>");
    out.println(
"<tr><td width=20%><input type=\"Submit\" value=\"Check\" name=\"Check\"></td>" +
"<td width=20%><input type=\"Submit\" value=\"Generate\" name=\"Generate\"></td>" +
      "<td width=20%><input type=\"Submit\"value=\"Set\" name=\"Set\"></td>" +
      "<td width=40%>&nbsp;</td></tr></table>");
    out.println(
    "<p><font face=\"Arial\" color=#DB1260 size=2><b>* mandatory</b></font><br>");
    out.println(
"<font face=\"Arial\" color=green size=2><b>* mandatory for Set</b></font></p><hr>");
    if (msg.length() > 0)
      out.println(msg);
    else
      out.println("No message");
    out.println(
      "<hr>Alexis Grandemange (c) 2000-2001 GNU GPL 2\n</font></body></html>");
    out.flush();
  }
  /** Initialize parameters. */
  private final void initialize() {
    Repository = curDir;
    repositoryURL = "";
    MaxLength = 155648;
    Logfile = Repository + File.separator + "publish.log";
    PageBoxURLs = Repository + File.separator + "PageBoxURLs.ser";
    webXml = Repository + File.separator + "WEB-INF";
    publisherURL = "http://pagebox.net/PublisherServer.jar";
    toTrace = true;
    msg = "";
  }
  /** Checks parameter validity */
  private final void check() {
    msg = "";
    if ((repositoryURL == null) || (repositoryURL.length() == 0))
      msg +=
"<font color=green face=\"Arial\" size=2><b>Mandatory: repository URL must be set.</b></font><BR>\n";
    if ((Repository != null) && (Repository.length() > 0)) {
      File f = new File(Repository);
      if (!f.exists())
        msg += "Warning: " + Repository + " doesn't exist.<BR>\n";
      else
      if (!f.isDirectory())
        msg += "<font color=red face=\"Arial\" size=2><b>Error: " + Repository +
          " is not a directory.</b></font><BR>\n";
      if (Repository.equals(curDir))
        msg += "Warning: Do you really want to use " + Repository +
          " as archive repository?<BR>\n";
      else {
        if (Logfile == null || Logfile.length() == 0 || Logfile.startsWith(curDir))
          Logfile = Repository + File.separator + "publish.log";
        if (PageBoxURLs == null || PageBoxURLs.length() == 0 ||
          PageBoxURLs.startsWith(curDir))
          PageBoxURLs = Repository + File.separator + "PageBoxURLs.ser";
        if (webXml == null || webXml.length() == 0 || webXml.startsWith(curDir))
          webXml = Repository + File.separator + "WEB-INF";
      }
    } else
      msg += "Warning: archive repository is not set<BR>\n";
    if ((Logfile != null) && (Logfile.length() > 0)) {
      File f = new File(Logfile);
      if (f == null)
        msg +=
      "<font color=red face=\"Arial\" size=2><b>Error: invalid log file name (" +
          Logfile + ")</b></font><BR>\n";
      else {
        f = f.getParentFile();
        if (f == null || !f.exists())
          msg += "Warning: directory where to create logs (" + f.getName() +
            ") doesn't exist<BR>\n";
        else
        if (!f.canWrite())
          msg +=
"<font color=red face=\"Arial\" size=2><b>Error: unable to create log file in " +
          f.getAbsolutePath() + "</b></font><BR>\n";
      }
    } else
      msg += "Warning: log file is not set<BR>\n";
    if ((PageBoxURLs != null) && (PageBoxURLs.length() > 0)) {
      File f = new File(PageBoxURLs);
      f = f.getParentFile();
      if (!f.exists())
        msg += "Warning: directory where to create PageBoxURLs serialized file (" +
          f.getName() + ") doesn't exist<BR>\n";
      else
      if (!f.canWrite())
        msg +=
"<font color=red face=\"Arial\" size=2><b>Error: unable to create PageBoxURLs serialized file in " +
          f.getAbsolutePath() + "</b></font><BR>\n";
    } else
      msg += "Warning: PageBoxURLs serialized file is not set<BR>\n";
    if (request.getParameter("trace") != null)
      toTrace = true;
    else
      toTrace = false;
  }
  /**
   * Generates and returns a web.xml file.
   * @param     out PrintWriter.
   * @param     bHTTP true - set response time (HTTP flow).
   */
  private final boolean generate(PrintWriter out, boolean bHTTP) {
    if (bHTTP)
      msg = "";
    if ((repositoryURL == null) || (repositoryURL.length() == 0)) {
      msg = "Repository URL must be set to generate\n";
      return false;
    }
    if ((Repository == null) || (Repository.length() == 0)) {
      File f = new File(".");
      Repository = f.getAbsolutePath();
    }
    if ((Logfile == null) || (Logfile.length() == 0))
      Logfile = Repository + File.separator + "publish.log";
    if ((PageBoxURLs == null) || (PageBoxURLs.length() == 0))
      PageBoxURLs = Repository + File.separator + "PageBoxURLs.ser";
    if (MaxLength == 0)
      MaxLength = 155648;
    if (bHTTP)
      response.setContentType("text/xml");
    out.println(
"<!DOCTYPE web-app\nPUBLIC \"-//Sun Microsystems, Inc.//DTD Web Application 2.2//EN\"\n" +
      "\"http://java.sun.com/j2ee/dtds/web-app_2_2.dtd\">");
    out.println("<!-- Review on " + ia.getHostName() + "\n");
    File f = new File(Repository);
    if (!f.exists()) {
      out.println("\tACTION: Create repository directory:" + Repository);
      out.println("\tACTION: Configure HTTP server to access " + Repository +
        " with " + repositoryURL);
    } else
    if (!f.isDirectory()) {
      out.println("\tERROR: Invalid repository " + Repository +
        ": is not a directory");
      out.println("\tACTION: Configure HTTP server to access " + Repository +
        " with " + repositoryURL);
    } else {
      PrintWriter pw = null;
      File pcTestFile = new File(f, "PublishConfig.test");
      try {
        pw = new PrintWriter(new BufferedWriter(
          new FileWriter(pcTestFile)));
      }
      catch(IOException ioe) {
        out.println("\tERROR: Unable to write on " + Repository);
      }
      if (pw != null) {
        pw.println("PublishConfig test");
        pw.close();
        try {
          URL url = new URL(repositoryURL);
          InputStream is = url.openStream();
          is.close();
        }
        catch(MalformedURLException mue) {
          out.println("\tERROR: Invalid repository URL " + repositoryURL);
        }
        catch(IOException ioe) {
          out.println("\tERROR: Repository URL " + repositoryURL +
            " doesn't point on " + Repository);
        }
      }
      pcTestFile.delete();
    }
    f = new File(Logfile);
    f = f.getParentFile();
    if (!f.exists()) {
      out.println("\tACTION: Create log directory:" + f.getAbsolutePath());
    }
    f = new File(PageBoxURLs);
    f = f.getParentFile();
    if (!f.exists()) {
      out.println("\tACTION: Create PageBoxURLs directory:" + f.getAbsolutePath());
    }
    out.println("-->\n");
    out.println(
      "\n\n<web-app>\n\t<servlet>\n\t\t<servlet-name>publish</servlet-name>\n" +
      "\t\t<servlet-class>PublisherServer.PublisherServlet</servlet-class>\n");
    out.println(JSPservletConfig.genParm("Repository",
      Repository.replace('\\', '/'), "Archive repository"));
    out.println(JSPservletConfig.genParm("Maxlength", "" + MaxLength,
      "max archive size"));
    if (request.getParameter("trace") != null) {
      toTrace = true;
      out.println(JSPservletConfig.genParm("toTrace", "TRUE", "trace activation"));
    } else {
      toTrace = false;
      out.println(JSPservletConfig.genParm("toTrace", "FALSE", "trace activation"));
    }
    out.println(JSPservletConfig.genParm("Logfile", Logfile.replace('\\', '/'),
      "path of log file"));
    out.println(JSPservletConfig.genParm("PageBoxURLs", PageBoxURLs.replace('\\',
      '/'), "URLs where to publish archives serialized file"));
    String ru = repositoryURL;
    if (repositoryURL.startsWith("http://"))
      ru = repositoryURL.substring("http://".length());
    out.println(JSPservletConfig.genParm("repositoryURL", ru,
      "URL where to download archives"));
    out.println(
"\t</servlet>\n\n\t<servlet>\n\t\t<servlet-name>publishLog</servlet-name>\n\t\t" +
"<servlet-class>PublisherServer.PublisherLog</servlet-class>\n\t</servlet>\n\n");
    out.println(
"\t</servlet>\n\n\t<servlet>\n\t\t<servlet-name>archiveList</servlet-name>\n\t\t" +
"<servlet-class>PublisherServer.PublisherArchive</servlet-class>\n\t</servlet>\n\n");
    out.println(JSPservletConfig.genMapping("publish", "/publish"));
    out.println(JSPservletConfig.genMapping("publishLog", "/publishLog"));
    out.println(JSPservletConfig.genMapping("archiveList", "/archiveList"));
    out.println("</web-app>");
    return true;
  }
  /**
   * method setting remote environment in order to host PublishServlet.
   * should be invoked only if JSPservletConfig is installed on the target machine.
   */
  void setenv() {
    msg = "";
    if (request.getParameter("trace") != null)
      toTrace = true;
    else
      toTrace = false;
    if ((Repository != null) && (Repository.length() > 0) &&
      !Repository.equals(curDir)) {
      File f = new File(Repository);
      if (!f.exists())
        f.mkdirs();
    }
    if ((Logfile != null) && (Logfile.length() > 0)) {
      File f = new File(Logfile);
      f = f.getParentFile();
      if (!f.exists())
        f.mkdirs();
    }
    if ((PageBoxURLs != null) && (PageBoxURLs.length() > 0)) {
      File f = new File(PageBoxURLs);
      f = f.getParentFile();
      if (!f.exists())
        f.mkdirs();
    }
    File parent = null; // created in webXml step and used in publisherURL step
    if ((webXml != null) && (webXml.length() > 0)) {
      if (!webXml.endsWith("WEB-INF")) {
        msg +=
"<font color=red face=\"Arial\" size=2><b>Error: invalid web.xml directory:" +
          webXml + ". Should end with WEB-INF</b></font><BR>\n";
        return;
      }
      File f = new File(webXml);
      if (!f.exists())
        f.mkdirs();
      PrintWriter pw = null;
      try {
        pw = new PrintWriter(new BufferedWriter(
          new FileWriter(webXml + File.separator + "web.xml", false)));
      }
      catch(IOException ioe) {
        msg +=
          "<font color=red face=\"Arial\" size=2><b>Error: unable to create " +
          File.separator + "web.xml" + webXml + "<BR>\n" + ioe +
          "</b></font><BR>\n";
        return;
      }
      generate(pw, false);
      pw.close();
      parent = f.getParentFile();
    }
    if ((publisherURL != null) && (publisherURL.length() > 0)) {
      try {
        URL url = new URL(publisherURL);
        InputStream is = url.openStream();
        JarInputStream jis = new JarInputStream(is);
        JarEntry je = null;
        while((je = jis.getNextJarEntry()) != null) {
          String entryName = je.getName();
          if (entryName.endsWith(".class") || entryName.endsWith(".html")) {
            BufferedInputStream bis = new BufferedInputStream(jis);
            File f = new File(parent, entryName);
            File p = f.getParentFile();
            if (!p.exists())
              p.mkdirs();
            BufferedOutputStream bos = new BufferedOutputStream(
              new FileOutputStream(f));
            int i;
            while((i = bis.read()) != -1)
              bos.write(i);
            bos.close();
            // bis.close();
          }
        }
        is.close();
      }
      catch(Exception e) {
        msg += "<font color=red face=\"Arial\" size=2><b>Error: unable to access "
          + publisherURL + "<BR>\n" + e + "</b></font><BR>\n";
        return;
      }
    }
  }
}


